#TITLE=Asterisk commands & functions
#SORT=n
; Asterisk Commands & functions file written by nsnake 
; You can find me at http://blog.sakuras.cn or loveme1314@gmail.com

#T=-----General commands-----

#T=Authenticate:Authenticate a user 
Authenticate
#T=Bridge: Connect two arbitrary callers (1.6+) 
Bridge
#T=ChannelRedirect:Redirect an existing channel to the dialplan 
ChannelRedirect
#T=Curl: Allows for the retrieval of external URLs.
Curl
#T=DUNDiLookup: Look up a number with DUNDi (Deprecated 1.2,Removed 1.4+) 
DUNDiLookup
#T=JabberSend: Send a text message via Jabber 
JabberSend
#T=Page: Page a mobile device (new in Asterisk v1.2) 
Page
#T=SendDTMF: Sends arbitrary DTMF digits
SendDTMF
#T=SendImage: Send an image file 
SendImage
#T=SendText: Send client a text message 
SendText
#T=SendURL: Send a client a URL to display 
SendURL
#T=System: Execute a system command
System
#T=Transfer: Transfer caller to remote extension
Transfer
#T=TrySystem: Execute a system command with always 0 returned 
TrySystem
#T=Wait: Waits for some time 
Wait
#T=WaitExten: Waits for some time for caller to dial a new extension 
WaitExten
#T=WaitForRing: Wait for Ring Application
WaitForRing
#T=WaitMusicOnHold: Wait, playing Music On Hold. Deprecated in favor of extended MusicOnHold. (Deprecated 1.6) 
WaitMusicOnHold

#T=-----Billing -----
#T=ForkCDR: Fork The CDR into 2 seperate entities 
ForkCDR
#T=NoCDR: Make sure asterisk doesn't save CDR for a certain call 
NoCDR
#T=ResetCDR: Reset CDR data 
ResetCDR
#T=SetAccount: Sets account code (Removed 1.4+) 
SetAccount
#T=SetAMAflags: Set the channel AMA Flags for billing 
SetAMAflags
#T=SetCDRUserField: Set CDR User field . Deprecated in favor of CDR(userfield)(Deprecated 1.4, Removed 1.6+) 
SetCDRUserField
#T=AppendCDRUserField: Append data to CDR User field. Deprecated in favor of CDR(userfield) (Deprecated 1.4,Removed 1.6+) 
AppendCDRUserField

#T=-----Call management-----
#T=AMD: Answering machine detection 
AMD
#T=Answer: Answer a channel if ringing 
Answer
#T=Busy: Indicate busy condition and wait for hangup 
Busy
#T=ChanIsAvail: Check if channel is available 
ChanIsAvail
#T=Congestion: Indicate congestion and wait for hangup
Congestion
#T=Dial: Place a call and connect to the current channel 
Dial
#T=DISA: DISA (Direct Inward System Access) 
DISA
#T=Hangup: Unconditional hangup 
Hangup
#T=RetryDial: Place a call, retrying on failure allowing optional exit extension. 
RetryDial
#T=Ringing: Indicate ringing 
Ringing

#T=-----Database handling-----
#T=DBdel: Delete a key from the database. 
DBdel
#T=DBdeltree: Delete a family or keytree from the database. 
DBdeltree
#T=DBget: Retrieve a value from the database. Deprecated in favor of DB. 
DBget
#T=DBput: Store a value in the database. Deprecated in favor of DB. 
DBput
#T=MYSQL: Perform various mySQL database activities 
MYSQL
#T=DBQuery: Execute predefined queries against MySQL Servers, and get the result back into the dialplan. 
DBQuery
#T=RealTime: Populate variables with details from database using RealTime 
RealTime
#T=RealTimeUpdate: Update a field in a database using RealTime 
RealTimeUpdate

#T=-----Application integration-----
#T=AGI: Executes an AGI compliant application 
AGI
#T=DeadAGI: Executes AGI on a hung-up channel 
DeadAGI
#T=EAGI: Executes an AGI compliant application with sound channels 
EAGI
#T=EnumLookup: Lookup number in ENUM 
EnumLookup
#T=ExternalIVR: Executes an ExternalIVR generator 
ExternalIVR
#T=Macro: Macro Implementation
Macro
#T=MacroExclusive: Only one channel at a time may call this macro, all others have to wait (1.4) 
MacroExclusive
#T=MacroExit: Exit the macro as if it had fully completed (1.4) 
MacroExit
#T=NoOp: No operation. Can print values to console for debugging. 
NoOp
#T=Perl: res_perl is the mod_perl of Apache, only for Asterisk
Perl
#T=PHP: res_php integrates PHP into Asterisk without AGI 
PHP
#T=Read: Read a variable with DTMF 
Read
#T=TXTCIDName: Lookup caller name from TXT record 
TXTCIDName
#T=UserEvent: Send an arbitrary event to the manager interface 
UserEvent

#T=----Control flow & timeouts----
#T=AbsoluteTimeout: Set absolute maximum time of call. Deprecated in favor of TIMEOUT(absolute) (Deprecated 1.2, Removed 1.4+)
AbsoluteTimeout
#T=DigitTimeout: Set maximum timeout between digits. Deprecated in favor of TIMEOUT(digit) (Deprecated 1.2, Removed 1.4+) 
DigitTimeout
#T=Gosub: Jump to a subroutine and return (new in v1.2)
Gosub
#T=GosubIf: Conditional jump to a subroutine and return (new in v1.2)
GosubIf
#T=Goto: Goto a particular priority, extension, or context 
Goto
#T=GotoIf: Conditional goto 
GotoIf
#T=GotoIfTime: Conditional goto on current time
GotoIfTime
#T=Random: jump to a specified location based on a random probability (Deprecated 1.4, Removed 1.6+) 
Random
#T=ResponseTimeout: Set maximum timeout awaiting response. Deprecated in favor of TIMEOUT(response) (Deprecated 1.2, Removed 1.4+) 
ResponseTimeout
#T=Return: Return from a Gosub or GosubIf (new in v1.2) 
Return
#T=StackPop: Remove a return address without returning (new in v1.2) 
StackPop
#T=While: Start A While Loop - *1.2beta 
While
#T=EndWhile: End A While Loop - *1.2beta 
EndWhile
#T=ExecIf: Conditional exec - *1.2beta 
ExecIf
#T=ExitWhile: End a While loop 
ExitWhile

#T=-----String & variable manipulation -----
#T=ImportVar: Set variable to value
ImportVar
#T=Math: Perform (rather simple) calculations. Deprecated in favor of MATH.
Math
#T=SetGlobalVar: Set variable to value. Deprecated in favor of Asterisk func global. 
SetGlobalVar
#T=Set: Set channel variable(s) or function value(s) 
Set
#T=DBRewrite: Execute perl compatible regular expression and substitution out of a MySQL Database. 
DBRewrite

#T=-----Sounds: Playback-----
#T=Background: Play a sound file while waiting an extension 
Background
#T=BackgroundDetect: Background a file with talk detect 
BackgroundDetect
#T=ControlPlayback: Play a sound file with fast forward, rewind and exit controls 
ControlPlayback
#T=DateTime: Say the date and/or time (Obsolete) 
DateTime
#T=Echo: Echo audio read back to the user 
Echo
#T=Festival: Say text with the Festival voice synthesizer 
Festival
#T=Flite: Say text with the Festival Lite voice synthesizer (faster response than Festival) 
Flite
#T=Milliwatt: Generate a Constant 1000Hz tone at 0dbm (mu-law) 
Milliwatt
#T=MP3Player: Play an MP3 sound file or stream 
MP3Player
#T=MusicOnHold: Play Music On Hold indefinitely 
MusicOnHold
#T=Playback: Play a sound file 
Playback
#T=Playtones: Play a tone list while executing other commands 
Playtones
#T=Progress: Play early audio to the caller before answering the line 
Progress
#T=SayUnixTime: Say the date and/or time 
SayUnixTime
#T=SayAlpha: Say Alpha 
SayAlpha
#T=SayDigits: Say Digits 
SayDigits
#T=SayNumber: Say Number 
SayNumber
#T=SayPhonetic: Say Phonetic 
SayPhonetic
#T=SetMusicOnHold: Set default Music On Hold class 
SetMusicOnHold
#T=SetLanguage: Change language setting for sound playback 
Set(CHANNEL(language)=)
#T=StopPlaytones: Stop playing a tone list 
StopPlaytones

#T=-----Sounds: Recording and monitoring-----
#T=ALSAMonitor: Monitor the ALSA console 
ALSAMonitor
#T=ChangeMonitor: Change monitoring filename of a channel
ChangeMonitor
#T=ChanSpy: Universal channel barge-in
ChanSpy
#T=Dictate: Records and plays back a dictation 
Dictate
#T=ExtenSpy: Listen/whisper to a specific extension (new in 1.4) 
ExtenSpy
#T=MixMonitor: Record and mix call legs natively (unlike Monitor) v1.2.x
MixMonitor
#T=Monitor: Record a telephone conversation to a sound file 
Monitor
#T=Record: Record user voice input to a file
Record
#T=StopMonitor: Stop monitoring a channel 
StopMonitor
#T=StopMixMonitor: Stop monitoring a channel monitored with MixMonitor
StopMixMonitor

#T=-----SIP commands-----
#T=SIPdtmfMode: Change DTMF mode during SIP call 
SIPdtmfMode
#T=SIP_HEADER(): Pick any header from a SIP invite message (replaces by SIPGetHeader) 
SIP_HEADER()
#T=SIPAddHeader: Add header to outbound SIP invite
SIPAddHeader

#T=-DAHDI (was ZAP) commands -
#T=Flash: Flashes a Zap Trunk 
Flash
#T=DAHDIBarge: Barge in (monitor) DAHDI channel (was ZapBarge) 
DAHDIBarge
#T=ZapCD: ISDN call deflection (bristuff) 
ZapCD
#T=BristuffZapEC: Echo cancellation on/off (bristuff)
#T=DAHDISendKeypadFacility: Send digits out of band over a PRI 
DAHDISendKeypadFacility
#T=DAHDIRAS: Provide ISDN data service (was ZapRAS) 
DAHDIRAS
#T=DAHDIScan: Scan DAHDI channels to monitor calls (was ZapScan) 
DAHDIScan

#T=-----Voicemail and conferencing-----
#T=Directory: Provide directory of voicemail extensions
Directory
#T=HasNewVoicemail: Conditionally branches to priority + 101 
HasNewVoicemail
#T=MailboxExists: Checks if mailbox exists 
MailboxExists
#T=MeetMe: Simple MeetMe conference bridge 
MeetMe
#T=MeetMeAdmin: MeetMe conference Administration 
MeetMeAdmin
#T=MeetMeCount: MeetMe participant count 
MeetMeCount
#T=MiniVM: Mini-Voicemail (new in v1.6)
MiniVM
#T=VoiceMail: Leave a voicemail message
VoiceMail
#T=VoiceMailMain: Enter voicemail system
VoiceMailMain
#T=VMAuthenticate: Authenticate a user based on voicemail.conf
VMAuthenticate

#T=-----Queue and ACD management-----
#T=AddQueueMember: Dynamically adds queue members 
AddQueueMember
#T=AgentCallbackLogin: Call agent callback login. Deprecated/removed. (Deprecated 1.4, Removed 1.6+) 
AgentCallbackLogin
#T=AgentLogin: Call agent login 
AgentLogin
#T=AgentMonitorOutgoing: Record agent's outgoing call 
AgentMonitorOutgoing
#T=ParkAndAnnounce: Park and Announce 
ParkAndAnnounce
#T=ParkedCall: Answer a parked call 
ParkedCall
#T=PauseQueueMember: Pauses an agent
PauseQueueMember
#T=Queue: Queue a call for a call queue 
Queue
#T=RemoveQueueMember: Dynamically removes queue members 
RemoveQueueMember
#T=UnpauseQueueMember: Resumes an agent 
UnpauseQueueMember


#T=----Functions----

#T=AGENT: Gets information about an Agent
AGENT
#T=ARRAY: Allows setting multiple variables at once 
ARRAY
#T=BASE64_DECODE: Decode a base64 string 
BASE64_DECODE
#T=BASE64_ENCODE: Encode a string into base64 
BASE64_ENCODE
#T=CALLERID: Get or set Caller*ID 
CALLERID
#T=CDR: Get or set a CDR variable 
CDR
#T=CHANNEL: Gets/sets various pieces of information about the channel.
CHANNEL
#T=CHECKSIPDOMAIN: Checks if domain is a local domain 
CHECKSIPDOMAIN
#T=CHECK_MD5: Checks an MD5 digest. Deprecated in 1.4, since it can be done with an expression in combination with MD5. 
CHECK_MD5
#T=clearhash: New in 1.6 
clearhash
#T=CURL: Retrieves a URL 
CURL
#T=CUT: String parsing, based upon a delimiter
CUT
#T=device_State: New in 1.6 allows retrieving any device state in the dialplan, as well as creating custom device states that are controllable from the dialplan 
device_State
#T=DB: Get or set a value in the AstDB 
DB
#T=DB_DELETE: Delete a value from the AstDB; replaces the DBDel application 
DB_DELETE
#T=DB_EXISTS: Check to see if a key exists in the Asterisk database
DB_EXISTS
#T=DIALGROUP: New in 1.6: Poor man's calling queue 
DIALGROUP
#T=dialplan_exists: New in 1.6 Check for the existence of a dialplan target 
dialplan_exists
#T=DUNDILOOKUP: Do a DUNDi lookup of a phone number. 
DUNDILOOKUP
#T=ENUMLOOKUP: General or specific querying of NAPTR records or counts of NAPTR types for ENUM or ENUM-like DNS pointers 
ENUMLOOKUP
#T=ENV: Get or set an environmental variable 
ENV
#T=EVAL: Evaluate stored variables.
EVAL
#T=EXISTS: Existence Test: Returns 1 if exists, 0 otherwise
EXISTS
#T=extension_state: New in 1.6 Allows retrieving the state of any extension
extension_state
#T=FIELDQTY: Get the number of fields, based upon a delimiter 
FIELDQTY
#T=GROUP: Can also return the name of the group set on a channel when used in a read environment
GROUP
#T=GROUP_COUNT: Counts the number of channels in the specified group 
GROUP_COUNT
#T=GROUP_LIST: Returns a space separated list of all of the groups set on a channel 
GROUP_LIST
#T=GROUP_MATCH_COUNT: Counts the number of channels in the groups matching the specified pattern 
GROUP_MATCH_COUNT
#T=HASH: New in 1.6 
HASH
#T=hashkeys: New in 1.6 
hashkeys
#T=hint: New in 1.6 Allows retrieving hint information 
hint
#T=IAXPEER: Gets IAX peer information 
IAXPEER
#T=iaxvar: Pass variables over IAX channels, somewhat similar to SIPADDHEADER() and SIP_HEADER() 
iaxvar
#T=IF: Conditional: Returns the data following '?' if true else the data following ':' 
IF
#T=IFTIME: Temporal Conditional: Returns the data following '?' if true else the data following ':'
IFTIME
#T=ISNULL: NULL Test: Returns 1 if NULL or 0 otherwise 
ISNULL
#T=KEYPADHASH: Hash the letters in the string into the equivalent keypad numbers. 
KEYPADHASH
#T=LANGUAGE: Get or set the channel's language 
LANGUAGE
#T=LEN: Get the length of an arbitrary string 
LEN
#T=MATH: Performs Mathematical Functions 
MATH
#T=MD5: Computes an MD5 digest 
MD5
#T=MUSICCLASS: Get or set the MusicOnHold class 
MUSICCLASS
#T=ODBC: Generic database access/queries using ODBC 
ODBC
#T=QUEUEAGENTCOUNT: Gets the number of members currently listening on a queue. Deprecated in favor of QUEUE_MEMBER_COUNT.
QUEUEAGENTCOUNT
#T=QUEUE_MEMBER_COUNT: Count number of members answering a queue 
QUEUE_MEMBER_COUNT
#T=QUEUE_MEMBER_LIST: Returns a list of interfaces on a queue 
QUEUE_MEMBER_LIST
#T=QUOTE: Quotes a given string, escaping embedded quotes as necessary 
QUOTE
#T=RAND: Choose a random number in a range 
RAND
#T=REALTIME: This function will read or write values from/to a RealTime repository.
REALTIME
#T=REGEX: Regular Expression: Returns 1 if data matches regular expression. 
REGEX
#T=SET: SET assigns a value to a channel variable 
SET
#T=SHA1: Computes a SHA1 digest 
SHA1
#T=SHARED: Implements shared channel variables (new in 1.6, backport for 1.4) 
SHARED
#T=SIPCHANINFO: Gets the specified SIP parameter from the current channel 
SIPCHANINFO
#T=SIPPEER: Gets SIP peer information 
SIPPEER
#T=SIPAddHeader: Typically used to set Alert-Info information, e.g. ring tone .wav files
SIPAddHeader
#T=SIP_HEADER: Gets or sets the specified SIP header 
SIP_HEADER
#T=SORT: Sorts a list of keys and values into a list of keys
SORT
#T=SQL_ESC: Escapes a value for inclusion in an SQL call (prevent injection attacks). 
SQL_ESC
#T=STAT: Does a check on the specified file 
STAT
#T=STRFTIME: Formats an epoch into an arbitrary datetime string 
STRFTIME
#T=STRPTIME: Returns the epoch of the arbitrary date/time string structured as described in the format. 
STRPTIME
#T=sysinfo: New in 1.6 Allows retrieval of system information 
sysinfo
#T=TIMEOUT: Gets or sets timeouts on the channel. 
TIMEOUT
#T=toupper: New in 1.6 Converts a string to uppercase 
toupper
#T=tolower: New in 1.6 Converts a string to lowercase 
tolower
#T=TXTCIDNAME: TXTCIDNAME looks up a caller name via DNS 
TXTCIDNAME
#T=URIDECODE: Decodes an URI-encoded string. 
URIDECODE
#T=URIENCODE: Encodes a string to URI-safe encoding.
URIENCODE
#T=VOLUME: New in 1.6 Set the TX or RX volume of a channel
VOLUME
#T=VMCOUNT: Counts the voicemail in a specified mailbox 
VMCOUNT
